<template>
<v-container>
  <v-form>
    <v-col cols="12" class="d-flex justify-space-between">
      <v-text-field
        v-model="urlText"
        dense
        label="URL Discovery da API"
        type="text"
        outlined
      ></v-text-field>
      <v-spacer/>
      <v-btn color="primary" small @click="getApiData(urlText)">
        <v-icon>mdi-magnify</v-icon>
        <v-spacer/>
        <span>Buscar</span>
      </v-btn>
    </v-col>
  </v-form>
  <vx-jsonViewer
    :json-viewer-options="jsonViewerOptions"
    :dataValue="JSON_API_DISCOVERY"
    body-style="max-height: 600px; overflow: scroll;"
  >
    <template v-slot:header>
      <span>Resultado</span>
      <v-spacer></v-spacer>
      <v-btn color="info" dense @click="goToHome">
        <v-icon>mdi-file-document</v-icon>
        <span> Ir para a documentação</span>
      </v-btn>
    </template>
  </vx-jsonViewer>
  <v-tooltip top>
    <span>Visualizar</span>
    <template v-slot:activator="{on}">
      <v-btn fixed dark fab bottom right color="orange" @click="goToHome" v-on="on">
        <v-icon>mdi-home</v-icon>
      </v-btn>
    </template>
  </v-tooltip>
</v-container>
</template>

<script>
import {mapActions, mapState} from "vuex";
import jsonViewer from "../components/JsonViewer.vue";

export default {
  name: 'Settings',
  components:{
    'vx-jsonViewer': jsonViewer
  },
  props:{
    dark: {
      type: Boolean,
      default: false
    }
  },
  data() {
		return {
      urlText: "",
    }
  },
  computed: {
    ...mapState(["API_URL_BASE", "JSON_API_DISCOVERY", "THEME"]),
    jsonViewerOptions(){
      return {
          maxDepth: 3,
          modifiable: false,
          link: true,
          limitRenderDepth: false,
          theme: (this.dark)
      }
    },

  },
  methods:{
    ...mapActions(["getApiData", "showSnack"]),
    getApiName(){
      return (this.JSON_API_DISCOVERY.nome) ? this.JSON_API_DISCOVERY.nome : "Documentação API"
    },
    goToHome(){
      this.$router.push({ name:'Home'})
    }
  },
  mounted(){
    if (this.API_URL_BASE !== "") {
      this.urlText = JSON.parse(JSON.stringify(this.API_URL_BASE))
    }
    if (this.THEME == 'dark'){
      this.dark = true
    }
  }
}
</script>